/*
 * 后台管理员
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class SysAdminController : BaseController
    {
        public SysAdminController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 后台管理员列表

        /// <summary>
        /// 根据条件查询后台管理员列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(SysAdmin data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            string Condition = "";
            Condition += "AdminName:\"" + data.AdminName + "\",";
            Condition += "RealName:\"" + data.RealName + "\",";
            Condition += "Role:\"" + data.Role + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询后台管理员列表

        /// <summary>
        /// 后台管理员列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(SysAdmin data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("AdminName", "2"); //用户名
            Fields.Add("RealName", "2"); //名称
            Fields.Add("Role", "1"); //角色
            Fields.Add("LastLoginDate", "3"); //最后登录时间

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("SysAdmin", Fields, "Id desc", "0", page, limit, " and Status>-1 and AdminName!='admin'");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //角色
                dic["Role"] = RelationClass.GetSysAdminRoleInfo(int.Parse(dic["Role"].ToString()));
            }
            return Json(obj);
        }

        #endregion

        #region 增加后台管理员

        /// <summary>
        /// 增加或修改后台管理员信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加后台管理员

        /// <summary>
        /// 增加或修改后台管理员信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(SysAdmin data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("AdminName", data.AdminName); //用户名
            Fields.Add("Password", function.MD5_32(data.Password)); //密码
            Fields.Add("RealName", data.RealName); //名称
            Fields.Add("Role", data.Role); //角色

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("SysAdmin", Fields, 0);
            AddSysLog(data.Id.ToString(), "SysAdmin", "add");
            bsdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改后台管理员

        /// <summary>
        /// 增加或修改后台管理员信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            SysAdmin editData = bsdb.SysAdmin.FirstOrDefault(m => m.Id == Id) ?? new SysAdmin();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改后台管理员

        /// <summary>
        /// 增加或修改后台管理员信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(SysAdmin data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("AdminName", data.AdminName); //用户名
            if (!string.IsNullOrEmpty(data.Password)) //密码不为空就修改密码，否则不操作
            {
                Fields.Add("Password", function.MD5_32(data.Password)); //密码
            }
            Fields.Add("RealName", data.RealName); //名称
            Fields.Add("Role", data.Role); //角色

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("SysAdmin", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "SysAdmin", "update");
            bsdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除后台管理员信息

        /// <summary>
        /// 删除后台管理员信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdmin", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("SysAdmin", Fields, id);
            }
            bsdb.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdmin", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("SysAdmin", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "SysAdmin", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("SysAdmin", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("SysAdmin", Sort, Id);

            AddSysLog(Id.ToString(), "SysAdmin", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                bsdb.SysAdmin.Add(new SysAdmin()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "SysAdmin", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(SysAdmin data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("AdminName", "2"); //用户名
            Fields.Add("RealName", "2"); //名称
            Fields.Add("Role", "1"); //角色
            Fields.Add("LastLoginDate", "3"); //最后登录时间

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("SysAdmin", Fields, "Id desc", "0", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "SysAdmin", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
